#!/usr/bin/env python
#########################################################
#              RETicker v. 0.4.4
# a programm to display xml-formatted rss/rdf-feeds in
# a one line display
#########################################################
# please read Help.txt for contact information

#########################################################
# This file contains the classes for all widgets to     #
# build the ticker-window                               #
#########################################################
from __future__ import generators
# import findrox; findrox.version(1,9,12)
# it uses a patched version of ROX-Lib2 in rox/
import rox
from rox import applet, g, tasks

import sys
import os

import tool
import overview	
from Options import *
from ticker_menu import *
from news import news_, show_list

global minsize ### a Identifier for miniatur icons
minsize = g.icon_size_register("minimal-size-9-9", 9, 9)

global v ### be verbose -- is set by AppRun
v = None

### old imports: mightbe deleted sometimes ;)
#from rox.options import Option
#from xml.dom import minidom
#import xml.sax
#import urllib
#import gc
#import re
#import time

### This is the Main-Container. To get overall access to its contens,
### it is defined a a global variable called main - its not really nice ;(
class MainContainer:
	def __init__(self):
                global main # Let this Instance be accessible from other instances like options-window
		main = self
        	### The box holds the Ticker-Label and the Ticker-Icon
		self.box = Label_box(); self.add(self.box)
		### news containing the actual feeds	
		self.news = news_(self.box)
		### show_list is a class wich presents a view of the news
		self.show_list = show_list(self.news, self.box)
		### this is the overview-window an contain
		self.overview = overview.ov_aktfeed()
		### set reaction to some signals
		self.connect("destroy", quit)
		self.box.set_callback_events(self, self.show_list)
		self.connect("destroy", quit)
		rox.app_options.add_notify(self.options_changed)
		### some formatting an done !
		self.set_size_request(hor_size.int_value, ver_size.int_value)
		self.show()
		### pixbufs for transparency -- and initialisation
		self.pixbuf_back = None; self.pixbuf = None
		self.pixbuf_label = None; self.pixbuf_image = None
		self.activate_transparency()
	### this is called if any Option has changed
	def options_changed(self):
		if update_time.has_changed:
			self.show_list.rem_update(); self.show_list.add_update()
		if refresh_time.has_changed:
			self.news.rem_refresh(); self.news.add_refresh()
		if hor_size.has_changed or ver_size.has_changed:
			self.set_size_request(hor_size.int_value, ver_size.int_value)
		if text_color.has_changed or back_color.has_changed:
			self.box.label.set_color()
		if transparent.has_changed or back_datei.has_changed:
			self.activate_transparency()
			### if transparency had changed, shake the window a little bit ;)
			### mightbe its better to tell this the win-manager directly
			x, y = self.window.get_position(); self.move(x+1, y); self.move(x-1, y)
		if back_color.has_changed and transparent.int_value <> 1:
			self.update_back_color()
	def update_back_color(self):
		self.modify_bg(g.STATE_NORMAL,self.get_colormap().alloc_color(back_color.value))
		self.box.label.modify_bg(g.STATE_NORMAL,\
			self.box.label.get_colormap().alloc_color(back_color.value))
		self.box.label.modify_bg(g.STATE_PRELIGHT,\
			self.box.label.get_colormap().alloc_color(tool.back_color_prelight()))
		self.box.image.modify_bg(g.STATE_NORMAL,\
			self.box.image.get_colormap().alloc_color(back_color.value))
		self.box.image.modify_bg(g.STATE_PRELIGHT,\
			self.box.image.get_colormap().alloc_color(tool.back_color_prelight()))
	def activate_transparency(self):
		if (transparent.int_value) == 0 or not(os.path.isfile(back_datei.value)):
			self.set_app_paintable(False)
			self.box.label.set_app_paintable(False)
			self.box.image.set_app_paintable(False)
			self.update_back_color()
			return
		### read background-image from File (set in Options)
		self.pixbuf_back = g.gdk.pixbuf_new_from_file(back_datei.value)
		self.set_app_paintable(True)
		self.box.label.set_app_paintable(True)
		self.box.image.set_app_paintable(True)
		self.connect('configure-event',self.refresh_background)
	def refresh_background(self, widget, value):
		w_b = self.pixbuf_back.get_width()
		h_b = self.pixbuf_back.get_height()
		x, y = self.window.get_position()
		w, h = self.get_size()
		if x < 0 or y < 0: return
		if x + w > w_b or y + h > h_b: return
		x_l, y_l = self.box.label.window.get_position()
		w_l, h_l = self.box.label.window.get_size()
		x_i, y_i = self.box.image.window.get_position()
		w_i, h_i = self.box.image.window.get_size()
		if self.pixbuf: del self.pixbuf
		self.pixbuf = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w, h)
		if self.pixbuf_label: del self.pixbuf_label
		self.pixbuf_label = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w_b - x - x_l, h_l)
		if self.pixbuf_image: del self.pixbuf_image
		self.pixbuf_image = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w_i, h_i)
		self.pixbuf_back.copy_area(x, y, w, h, self.pixbuf, 0, 0)
		self.pixbuf_back.copy_area(x+x_l, y+y_l, w_b - x - x_l, h_l, self.pixbuf_label, 0, 0)
		self.pixbuf_back.copy_area(x+x_i, y+y_i, w_i, h_i, self.pixbuf_image, 0, 0)
		self.pixmap, mask = self.pixbuf.render_pixmap_and_mask()
		self.pixmap_label, mask = self.pixbuf_label.render_pixmap_and_mask()
		self.pixmap_image, mask = self.pixbuf_image.render_pixmap_and_mask()
		self.window.set_back_pixmap(self.pixmap, False)
		self.box.label.window.set_back_pixmap(self.pixmap_label, False)
		self.box.image.window.set_back_pixmap(self.pixmap_image, False)
		self.resize(w,h)
		self.box.label.hide()
		self.box.label.show()
		self.box.image.hide()
		self.box.image.show()

### Program-Window
class TickerWindow(rox.Window, MainContainer):
        def __init__(self):
		rox.Window.__init__(self)
		MainContainer.__init__(self)
		self.position_menu = None
		self.set_title(" " + Version + " ")

### Program-applet
class TickerApplet(applet.Applet, MainContainer):
        def __init__(self):
                applet.Applet.__init__(self,sys.argv[1])
		MainContainer.__init__(self)

### if Applet or Window, the messages will be shown in the following
### box. It contain's the icon and the label and holds methods to
### set and reset mesages and icons
class Label_box(g.HBox):
    	def __init__(self):
    		g.HBox.__init__(self,g.FALSE, 0)
    		### set a little border, then there is space in applte for applet menu
		self.set_border_width(1)
		self.image = TickBild()
		self.label = TickLabel()
    		self.pack_start(self.image, g.FALSE, g.FALSE, 3)
    		self.pack_start(self.label, g.FALSE, g.FALSE, 3)
		self.show()
	### three kinds of methods to show status messages
	### those messages will be deleted after some seconds showing
	def status(self, Message):
		if check_verbose.int_value: self.label.set_status(Message)
		self.start_killTask()
	def status_1(self, Message, Stock):
		if check_verbose.int_value: self.label.set_status(Message)
		if check_verbose.int_value or check_image.int_value: self.image.set_from_stock_tmp(Stock)
		self.start_killTask()
	def status_2(self, Message, File, Stock):
		if check_verbose.int_value: self.label.set_status(Message)
		if check_verbose.int_value: self.image.get_from_file_tmp(File)
		if check_image.int_value: self.image.set_from_stock_tmp(Stock)
		self.start_killTask()
	def start_killTask(self):
		tasks.Task(self.kill_status_msg())
	def kill_status_msg(self):
		### this is the time for showing status messages
		yield tasks.TimeoutBlocker(3)
		self.label.reset()
		self.image.reset()
	### initiate callback-events, its importend to initiate them after initiating
	### after news and show_list in main class
	def set_callback_events(self, parent, show_list):
		self.label.set_callback_events(show_list)
		self.image.set_callback_events(parent, show_list)

### The folloing class contains the iconimage and is directly derived from EventImage
### as a special Feauture this class contains a second EventBuf, which enables storing
### and displaying of another icon as a (graphical) status-message
class TickBild(tool.EventImage):
	def __init__(self):
		tool.EventImage.__init__(self, g.STOCK_MISSING_IMAGE, None, None)
		self.get_from_file(rox.app_dir+"/AppIcon.xpm")
		self.tooltip = g.Tooltips(); self.tooltip.enable()
		self.tooltip.set_tip(self, " " + Version + " ")
		self.EventBuf_tmp = tool.EventBuffers()  # a second Buffer for Status-Msg_Icons
	### second set of Methods for setting/resetting status Icon
	def get_from_file_tmp(self,Filename):
		self.EventBuf_tmp.get_from_file(self, Filename)
		self.image.set_from_icon_set(self.EventBuf_tmp.iconset, g.ICON_SIZE_SMALL_TOOLBAR)
	def set_from_stock_tmp(self, Stock):
		self.EventBuf_tmp.set_from_stock(self, Stock)
		self.image.set_from_icon_set(self.EventBuf_tmp.iconset, g.ICON_SIZE_SMALL_TOOLBAR)
	def reset(self):
		self.image.set_from_icon_set(self.EventBuf.iconset, g.ICON_SIZE_SMALL_TOOLBAR)
	### adding a tooltip as the user like it :)
	def addTip(self, fd, news):
		def brk_tip(tooltip):
			if tooltip == "": return ""
			else: return "\n"
		tooltip = ""
		if tt_i.int_value: 
			self.tooltip.enable()
			if tt_i_frame.int_value: tooltip += "---------------------------------------------"
			if tt_i_title.int_value: tooltip += brk_tip(tooltip) + "Ticker : " + tool.unxml(fd.title).encode("utf-8")
			if tt_i_frame.int_value: tooltip += brk_tip(tooltip) + "---------------------------------------------"
			if tt_i_desc.int_value:
				desc = fd.desc
				if len(desc) > 100: desc = desc[:100] + "..."
				tooltip += brk_tip(tooltip) + tool.unxml(desc).encode("utf-8")
			if tt_i_frame.int_value: tooltip += brk_tip(tooltip)
			if tt_i_src.int_value: tooltip += brk_tip(tooltip) + "Src : " + tool.unxml(fd.ticker).encode("utf-8")
			if tt_i_link.int_value: tooltip += brk_tip(tooltip) + "Link : " + tool.unxml(fd.link).encode("utf-8")
			if tt_i_ver.int_value:  tooltip += brk_tip(tooltip) + " *** " + Version + " *** \n" + news.stat()
			self.tooltip.set_tip(self, tooltip)
		else:
			self.tooltip.disable()
	### callbacks and initiating
	def set_callback_events(self, parent, show_list):
		self.con_show_list = show_list
		self.con_parent = parent
		self.connect("button_press_event", self.callback_image)
	def callback_image(self, widget, event):
		if event.button == 1: tasks.Task(self.con_show_list.open_page_feed())
        	if event.button == 2: self.con_show_list.update_ticker_()
		if event.button == 3: ticker_menu.open_menu(widget, event, self.con_parent.position_menu)
	### some Methods for Menu-Calls, they are landing here
	def quit(self): quit(None)
	def help(self): help()
	def info(self): info()
	def show_options(self): show_options()
	def update_ticker(self): main.show_list.update_ticker()
	def refresh_ticker(self): tasks.Task(main.news.refresh_ticker())
	def show_window(self): tasks.Task(overview.show_window())
	def enter_widget(self, widget, event):
		#print "show now"
		x, y = self.con_parent.window.get_position()
		w, h = self.con_parent.size_request()
		if tt_a.int_value == 1: self.con_parent.overview.show_now(x, y, w, h)
		widget.set_state (g.STATE_PRELIGHT)
	def leave_widget(self, widget, event):
		self.con_parent.overview.hide_now()
		widget.set_state (g.STATE_NORMAL)

### The next Class is a label with two kinds of messages, news and status messages
### news messages should be shown always, but status messages should only be shown
### for some seconds (see parent box class)
class TickLabel(g.EventBox):
	def __init__(self):
		g.EventBox.__init__(self)
		#### create the main label
		self.text = " " + Version + " " # There the real Message is stored while showing status Message
		self.label = g.Label(self.text)
		self.label.show()
		self.add(self.label)
		self.tooltip = g.Tooltips(); self.tooltip.enable()
		self.tooltip.set_tip(self, " " + Version + " ")
		self.set_events(g.gdk.ENTER_NOTIFY_MASK | g.gdk.LEAVE_NOTIFY_MASK)
		self.connect("enter-notify-event", self.enter_widget)
		self.connect("leave-notify-event", self.leave_widget)
		self.set_color()
		self.show()
	def set_status(self, Label): #show status-messages only if wished
		self.label.set_text(Label)
	def reset(self):
		self.label.set_text(self.text)
	def update(self,Label):
		self.text = Label
		self.label.set_text(self.text)
	def set_color(self):
		self.label.modify_fg(g.STATE_NORMAL, g.gdk.color_parse(text_color.value))
		self.label.modify_fg(g.STATE_PRELIGHT, tool.text_color_prelight())
	def addTip(self, i):
		def brk_tip(tooltip):
			if tooltip == "": return ""
			else: return "\n"
		tooltip = ""
		if tt_l.int_value: 
			self.tooltip.enable()
			if tt_l_frame.int_value: tooltip += "---------------------------------------------"
			if tt_l_title.int_value: tooltip += brk_tip(tooltip) + tool.unxml(i.title).encode("utf-8")
			if tt_l_frame.int_value: tooltip += brk_tip(tooltip) + "---------------------------------------------"
			tooltip += brk_tip(tooltip) + tool.unxml(i.desc).encode("utf-8")
			if tt_l_frame.int_value: tooltip += brk_tip(tooltip)
			if tt_l_link.int_value: tooltip += brk_tip(tooltip) + "Link   : " + tool.unxml(i.link).encode("utf-8")
			if tt_l_ver.int_value:  tooltip += brk_tip(tooltip) + " *** " + Version + " *** "
			self.tooltip.set_tip(self, tooltip)
		else:
			self.tooltip.disable()
	def enter_widget(self, widget, event):
		main.show_list.rem_update()
		widget.set_state (g.STATE_PRELIGHT)
	def leave_widget(self, widget, event):
		main.show_list.add_update()
		widget.set_state (g.STATE_NORMAL)
	def set_callback_events(self, show_list):
		self.con_show_list = show_list
		self.connect("button_press_event", self.callback_label)
	def callback_label(self, widget, event):
		if event.button == 1: tasks.Task(self.con_show_list.open_page())
        	if event.button == 2: self.con_show_list.update_ticker_()
		if event.button == 3: self.con_show_list.update_ticker_()

